unit RSCONFIG;

INTERFACE

uses crt,rsglob,turbolib,turbotxt,turboftr;

const
     MaxProp = 40;

type
    Param = Record
                   Port     : string[1];
                   BDonnees : string[1];
                   BStop    : string[1];
                   Parite   : string[7];
                   Vitesse  : string[4];
                   Codage   : string[5];
                   Protocole: string[8];
                   Nb_Ligne : string[3];
                   Recherche: string[3];
                   Affichage: string[3];

              End;
var
    Proposition : typChoix;
    Z           : byte;

    ParamRS     : array [1..2] of Param;
    Param_Tmp   : Param;

    ReglageRS   : array [1..2] of byte;
    Reglage_Tmp : byte;

    Numero      : byte;

    Fic_Config  : text;
    Fic_Tmp     : text;
    Ligne       : str80;

    Tampon      : str80;
    Remplace    : boolean;
    Ok          : boolean;

Procedure CalculReglage;
Procedure Menu_Config;
Procedure Ferme_Config;

IMPLEMENTATION

{--------------------------------------------------------------------------}

procedure AfficheConfig;

var
    Z : byte;
    TxtTempo : string[8];

Begin
     CoulTexte(CTexte);
     CoulFond(CFond);
     for Z := 7 to 19 do CentreTexte(z,' ');
     for Z := 0 to 1 do
     with ParamRS[Z+1] do
     Begin
          gotoxy(6+(40*Z),7);
          write('Port srie       : ',Port);
          gotoxy(6+(40*Z),8);
          write('Bits de donnes  : ',BDonnees);
          gotoxy(6+(40*Z),9);
          write('Bits de stop     : ',BStop);
          TxtTempo := ElargiADte(Parite,7);
          gotoxy(6+(40*Z),10);
          write('Parit           : ',TxtTempo);
          TxtTempo := ElargiADte(Vitesse,4);
          gotoxy(6+(40*Z),11);
          write('Vitesse          : ',TxtTempo);
          TxtTempo := ElargiADte(Codage,5);
          gotoxy(6+(40*Z),13);
          write('Codage           : ',TxtTempo);
          TxtTempo := ElargiADte(Protocole,8);
          gotoxy(6+(40*Z),14);
          write('Protocole        : ',TxtTempo);
          gotoxy(6+(40*Z),15);
          write('Nb lignes  sup. : ',Nb_Ligne);
          gotoxy(6+(40*Z),16);
          write('Recherche dbut  : ',Recherche);
          gotoxy(6+(40*Z),18);
          write('Affichage caract.: ',Affichage);

     End;
     CoulTexte(CTMenu);
     CoulFond(CFMenu);
     gotoxy(15,5);
     write(' Emission ');
     gotoxy(55,5);
     write(' Rception ');
     Message(CTTitre,CFond,
      ' Attention : ISO passe automatiquement en 7 bits,Paire ',22,false);
     Message(CTTitre,CFond,
      '             EIA passe automatiquement en 8 bits,Sans  ',23,false);
     Message(CTMenu,CFMenu,'  Appuyez sur ESC pour sortir  ',24,false);
End;

{------------------------------------------------------------------------}

procedure ChangePort;

Begin
     Proposition[1]^ := '1';
     Proposition[2]^ := '2';
     Resultat := 0;
     if not Choix(38,6,2,2,Resultat,Proposition) then exit
        else
            ParamRS[Numero].Port := Proposition[Resultat]^;
     AfficheConfig;
End;

{-----------------------------------------------------------------------}

procedure ChangeBDonnees;

Begin
     Proposition[1]^ := '7';
     Proposition[2]^ := '8';
     Resultat := 0;
     if not Choix(38,7,2,2,Resultat,Proposition) then exit
        else
            ParamRS[Numero].BDonnees := Proposition[Resultat]^;
     AfficheConfig;
End;

{-----------------------------------------------------------------------}

procedure ChangeBStop;

Begin
     Proposition[1]^ := '1';
     Proposition[2]^ := '2';
     Resultat := 0;
     if not Choix(38,8,2,2,Resultat,Proposition) then exit
        else
            ParamRS[Numero].BStop := Proposition[Resultat]^;
     AfficheConfig;
End;

{-----------------------------------------------------------------------}

procedure ChangeParite;

Begin
     Proposition[1]^ := 'SANS';
     Proposition[2]^ := 'IMPAIRE';
     Proposition[3]^ := 'PAIRE';
     Resultat := 0;
     if not Choix(35,8,3,3,Resultat,Proposition) then exit
        else
            ParamRS[Numero].Parite := Proposition[Resultat]^;
     AfficheConfig;
End;

{-----------------------------------------------------------------------}

procedure ChangeVitesse;

Begin
     Proposition[1]^ := '110';
     Proposition[2]^ := '150';
     Proposition[3]^ := '300';
     Proposition[4]^ := '600';
     Proposition[5]^ := '1200';
     Proposition[6]^ := '2400';
     Proposition[7]^ := '4800';
     Proposition[8]^ := '9600';
     Resultat := 0;
     if not Choix(36,7,8,8,Resultat,Proposition) then exit
        else
            ParamRS[Numero].Vitesse := Proposition[Resultat]^;
     AfficheConfig;
End;

{-----------------------------------------------------------------------}

procedure ChangeNb_Ligne;

var
   Nombre : integer;

Begin
     CoulDialogues := CFMenu;
     CoulTextes := CTMenu;
     val(ParamRS[Numero].Nb_Ligne,Nombre,Err);
     Nombre := DialogueNbr('Nb lignes  sup. (0..255)',0,255,Nombre);
     str(Nombre:3,ParamRS[Numero].Nb_Ligne);
     AfficheConfig;
End;

{-----------------------------------------------------------------------}

procedure ChangeRecherche;

var
   Rech_Car : str80;
   Titre    : str80;

Begin
     Proposition[1]^ := 'OUI';
     Proposition[2]^ := 'NON';
     Resultat := 0;
     if not Choix(37,15,2,2,Resultat,Proposition) then exit
        else
            if Resultat = 2 then
               ParamRS[Numero].Recherche := Proposition[Resultat]^
               else begin
                    CoulDialogues := CFMenu;
                    CoulTextes := CTMenu;
                    Titre := 'Caractre  rechercher :';
                    Rech_Car := DialogueTexte(Titre,'%',1);
                    ParamRS[Numero].Recherche := ElargiAGch(Rech_Car,3);
               end;
     AfficheConfig;
End;

{-----------------------------------------------------------------------}

procedure ChangeCodage;

Begin
     Proposition[1]^ := 'ISO';
     Proposition[2]^ := 'EIA';
     Proposition[3]^ := 'ASCII';
     Resultat := 0;
     if not Choix(35,11,3,3,Resultat,Proposition) then exit
        else
            ParamRS[Numero].Codage := Proposition[Resultat]^;
     if ParamRS[Numero].Codage = 'ISO' then
        Begin
             ParamRS[Numero].BDonnees := '7';
             ParamRS[Numero].Parite := 'PAIRE';
        End;
     if ParamRS[Numero].Codage = 'EIA' then
        Begin
             ParamRS[Numero].BDonnees := '8';
             ParamRS[Numero].Parite := 'SANS';
        End;
     AfficheConfig;
End;

{-----------------------------------------------------------------------}

procedure ChangeProtocole;

Begin
     Proposition[1]^ := 'SANS';
     Proposition[2]^ := 'XON/XOFF';
     Resultat := 0;
     if not Choix(35,13,2,2,Resultat,Proposition) then exit
        else
            ParamRS[Numero].Protocole := Proposition[Resultat]^;
     AfficheConfig;
End;

{-----------------------------------------------------------------------}

procedure ChangeAffichage;

Begin
     Proposition[1]^ := 'OUI';
     Proposition[2]^ := 'NON';
     Resultat := 0;
     if not Choix(35,17,2,2,Resultat,Proposition) then exit
        else
            ParamRS[Numero].Affichage := Proposition[Resultat]^;
     AfficheConfig;
End;

{-----------------------------------------------------------------------}

procedure ModifConfig;

var
   Colonne     : byte;
   Ligne       : byte;
   Larg        : byte;
   Selectionne : boolean;
   Sortie      : boolean;
   Stockage    : boolean;
   car         : char;

Begin
     Colonne := 25;
     Ligne := 7;
     Numero := 1;
     Larg := 1;
     Sortie := false;
  repeat
     Selectionne := false;
     InverseTexte(Colonne,Ligne,Larg);
     repeat
           car := readkey;
           if (car = flchBas) and (Ligne = 11) then Ligne := 12;
           if (car = flchHaut) and (Ligne = 13) then Ligne := 12;
           if (car = flchBas) and (Ligne = 16) then Ligne := 17;
           if (car = flchHaut) and (Ligne = 18) then Ligne := 17;
           if car = flchBas then Ligne := Ligne + 1;
           if car = flchHaut then Ligne := Ligne - 1;
           if Ligne = 19 then Ligne := 7;
           if Ligne = 6 then Ligne := 18;
           if (car = flchDroite) and (Colonne = 25) then
              Begin
                   Colonne := 65;
                   Numero := 2;
                   car := carNul;
              End;
           if (car = flchDroite) and (Colonne = 65) then
              Begin
                   Colonne := 25;
                   Numero := 1;
                   car := carNul;
              End;
           if (car = flchGauche) and (Colonne = 65) then
              Begin
                   Colonne := 25;
                   Numero := 1;
                   car := carNul;
              End;
           if (car = flchGauche) and (Colonne = 25) then
              Begin
                   Colonne := 65;
                   Numero := 2;
                   car := carNul;
              End;
           case Ligne of 10 : Larg :=7;
                         11 : Larg := 4;
                         13 : Larg := 5;
                         14 : Larg := 8;
                         15 : Larg := 3;
                         16 : Larg := 3;
                         18 : Larg := 3;
           else Larg := 1;
           End;
           InverseTexte(Colonne,Ligne,Larg);
           if car = carRet then Selectionne := true;
           if car = carEsc then Begin
                                     Selectionne := true;
                                     Sortie := true;
                                End;
     until Selectionne;
     if not Sortie then
                       case Ligne of  7 : ChangePort;
                                      8 : ChangeBDonnees;
                                      9 : ChangeBStop;
                                     10 : ChangeParite;
                                     11 : ChangeVitesse;
                                     13 : ChangeCodage;
                                     14 : ChangeProtocole;
                                     15 : ChangeNb_Ligne;
                                     16 : ChangeRecherche;
                                     18 : ChangeAffichage;
                       End;
  until Sortie;
  CoulDialogues := grisclair;
  CoulTextes := blanc;
End;

{------------------------------------------------------------------------}

procedure CalculReglage;

Begin
     Reglage_Tmp := 0;
     with Param_Tmp do Begin
          if BDonnees = '7' then Reglage_Tmp := Reglage_Tmp + 2;
          if BDonnees = '8' then Reglage_Tmp := Reglage_Tmp + 3;

          if BStop = '2' then Reglage_Tmp := Reglage_Tmp + 4;

          if Parite = 'IMPAIRE' then Reglage_Tmp := Reglage_Tmp + 8;
          if Parite = 'PAIRE' then Reglage_Tmp := Reglage_Tmp + 24;

          if Vitesse = '150' then Reglage_Tmp := Reglage_Tmp + 32;
          if Vitesse = '300' then Reglage_Tmp := Reglage_Tmp + 64;
          if Vitesse = '600' then Reglage_Tmp := Reglage_Tmp + 96;
          if Vitesse = '1200' then Reglage_Tmp := Reglage_Tmp + 128;
          if Vitesse = '2400' then Reglage_Tmp := Reglage_Tmp + 160;
          if Vitesse = '4800' then Reglage_Tmp := Reglage_Tmp + 192;
          if Vitesse = '9600' then Reglage_Tmp := Reglage_Tmp + 224;
     End;
End;

{------------------------------------------------------------------------}
procedure Remplace_Config;

Begin
     if Nom_Config = '' then exit;
     reset (Fic_Config);
     while not eof(Fic_Config) do Begin
           readln(Fic_Config,Ligne);
           if compresse(Ligne) = Nom_Config then Begin
              readln(Fic_Config,Ligne);
              writeln(Fic_Tmp,Nom_Config);
              with ParamRS[1] do Begin
                   Ligne := Port + BDonnees + BStop + elargi(Parite,7);
                   Ligne := Ligne + elargi(Vitesse,4)+ elargi(Codage,5);
                   Ligne := Ligne + elargi(Protocole,8);
                   Ligne := Ligne + elargi(Nb_Ligne,3) + Recherche;
                   Ligne := Ligne + Affichage + '/';
              End;
              with ParamRS[2] do Begin
                   Ligne := Ligne + Port + BDonnees + BStop + elargi(Parite,7);
                   Ligne := Ligne + elargi(Vitesse,4)+ elargi(Codage,5);
                   Ligne := Ligne + elargi(Protocole,8);
                   Ligne := Ligne + elargi(Nb_Ligne,3) + Recherche ;
                   Ligne := Ligne + Affichage;
              End;
              writeln(Fic_Tmp,Ligne);
              End
              else Begin
                   writeln(Fic_Tmp,Ligne);
                   readln(Fic_Config,Ligne);
                   writeln(Fic_Tmp,Ligne);
              End;
           End;
End;

{------------------------------------------------------------------------}
procedure Ecrit_Config;

Begin
     if Nom_Config = '' then exit;
     reset(Fic_Config);
     while not eof(Fic_Config) do Begin
           readln(Fic_Config,Ligne);
           writeln(Fic_Tmp,Ligne);
           readln(Fic_Config,Ligne);
           writeln(Fic_Tmp,Ligne);
           End;
     writeln(Fic_Tmp,Nom_Config);
     with ParamRS[1] do Begin
          Ligne := Port + BDonnees + BStop + elargi(Parite,7);
          Ligne := Ligne + elargi(Vitesse,4)+ elargi(Codage,5);
          Ligne := Ligne + elargi(Protocole,8);
          Ligne := Ligne + elargi(Nb_Ligne,3) + Recherche;
          Ligne := Ligne + Affichage + '/';
          End;
     with ParamRS[2] do Begin
          Ligne := Ligne + Port + BDonnees + BStop + elargi(Parite,7);
          Ligne := Ligne + elargi(Vitesse,4)+ elargi(Codage,5);
          Ligne := Ligne + elargi(Protocole,8);
          Ligne := Ligne + elargi(Nb_Ligne,3) + Recherche;
          Ligne := Ligne + Affichage;
          End;
     writeln(Fic_Tmp,Ligne);
End;

{-----------------------------------------------------------------------}

procedure Ecrire;

Begin
{$I-}
     assign(Fic_Tmp,'RS232.TMP');
     rewrite(Fic_Tmp);
     assign(Fic_Config,'RS232.CFG');
     reset(Fic_Config);
     if ioresult <> 0 then Begin
        tempAlertes := 0;
        Alerte('Fichier des configurations introuvable !!');
        MontreCurseur;
        CoulFond(noir);
        CoulTexte(grisclair);
        clrscr;
        halt;
        End;
     repeat
     Ok := true;
     Nom_Config := DialogueTexte('Nom de la configuration :','',30);
     Nom_Config := majuscules(Nom_Config);
     if Nom_Config = '' then Begin
        beep;
        Ok := false;
        End;
     if ord(Nom_Config[1]) = 0 then Begin
        close (Fic_Tmp);
        close(Fic_Config);
        {$I+}
        exit;
        End;
     Remplace := false;
     reset (Fic_Config);
     while not eof(Fic_Config) do Begin
           readln(Fic_Config,Ligne);
           if compresse(Ligne) = Nom_Config then Begin
              if DialogueBout('Fichier xistant . Ecraser ?','Oui','Non')
                 then Remplace := true
                 else Ok := false
              End;
           readln(Fic_Config,Ligne);
           End;
     until Ok;
     if Remplace then Remplace_Config
                 else Ecrit_Config;

     close (Fic_Tmp);
     close(Fic_Config);
     erase(Fic_Config);
     rename(Fic_Tmp,'RS232.CFG');
{$I+}
End;

{-----------------------------------------------------------------------}

procedure Creer;

Begin
     Fond;
     AfficheConfig;
     Message(CTTitre,CFTitre,'  CONFIGURATION RS232  ',2,false);
     Message(CTTitre,CFTitre,'  - Cration - ',3,false);
     ModifConfig;
     Ecrire;
End;

{------------------------------------------------------------------------}

procedure Editer;

Begin
     Fond;
     AfficheConfig;
     Tampon := ' - Edition config. ' + Nom_Config + ' - ';
     Message(CTTitre,CFTitre,'  CONFIGURATION RS232  ',2,false);
     Message(CTTitre,CFTitre,Tampon,3,false);
     ModifConfig;
     if DialogueBout('Enregistrer la configuration ?','Oui','Non') then
       if Nom_Config = 'DEFAULT' then Ecrire
          else Begin
               assign(Fic_Tmp,'RS232.TMP');
               rewrite(Fic_Tmp);
               assign(Fic_Config,'RS232.CFG');
               reset(Fic_Config);
               Remplace_Config;
               close (Fic_Tmp);
               close(Fic_Config);
               erase(Fic_Config);
               rename(Fic_Tmp,'RS232.CFG');
               End;
End;

{------------------------------------------------------------------------}

procedure Lire;

Begin
     Fond;
     Message(CTTitre,CFTitre,'  CONFIGURATION RS232  ',2,false);
     Message(CTTitre,CFTitre,' - Lecture - ',3,false);
{$I-}
     assign(Fic_Config,'RS232.CFG');
     reset(Fic_Config);
     if ioresult <> 0 then Begin
        tempAlertes := 0;
        Alerte('Fichier des configurations introuvable !!');
        MontreCurseur;
        CoulFond(noir);
        CoulTexte(grisclair);
        clrscr;
        halt;
        End;

     for z := 1 to MaxProp do Proposition[z]^:= '';
     z := 1;
     while not eof(Fic_Config) do Begin
           readln(Fic_Config,Ligne);
           Proposition[z]^ := compresse(Ligne);
           readln(Fic_Config,Ligne);
           z := z + 1;
           End;
     Message(blanc,grisclair,'  Choix de la configuration  ',7,false);
     Resultat := 0;
     CoulFond(CFMenu);
     CoulTexte(CTMenu);
     if not Choix(34,9,10,39,Resultat,Proposition) then exit
        else Nom_Config := majuscules(Proposition[Resultat]^);

     reset(Fic_Config);
     while not eof(Fic_Config) do Begin
           readln(Fic_Config,Ligne);
           if compresse(Ligne) = Nom_Config then Begin
              readln(Fic_Config,Ligne);
              with ParamRS[1] do Begin
                   Port := copy(Ligne,1,1);
                   delete(Ligne,1,1);
                   BDonnees := copy(Ligne,1,1);
                   delete(Ligne,1,1);
                   BStop := copy(Ligne,1,1);
                   delete(Ligne,1,1);
                   Parite := compresse(copy(Ligne,1,7));
                   delete(Ligne,1,7);
                   Vitesse := compresse(copy(Ligne,1,4));
                   delete(Ligne,1,4);
                   Codage := compresse(copy(Ligne,1,5));
                   delete(Ligne,1,5);
                   Protocole := compresse(copy(Ligne,1,8));
                   delete(Ligne,1,8);
                   Nb_Ligne := compresse(copy(Ligne,1,3));
                   delete(Ligne,1,3);
                   Recherche := compresse(copy(Ligne,1,3));
                   delete(Ligne,1,3);
                   Affichage := compresse(copy(Ligne,1,3));
                   delete(Ligne,1,3);
                   delete(Ligne,1,1);
              End;
              with ParamRS[2] do Begin
                   Port := copy(Ligne,1,1);
                   delete(Ligne,1,1);
                   BDonnees := copy(Ligne,1,1);
                   delete(Ligne,1,1);
                   BStop := copy(Ligne,1,1);
                   delete(Ligne,1,1);
                   Parite := compresse(copy(Ligne,1,7));
                   delete(Ligne,1,7);
                   Vitesse := compresse(copy(Ligne,1,4));
                   delete(Ligne,1,4);
                   Codage := compresse(copy(Ligne,1,5));
                   delete(Ligne,1,5);
                   Protocole := compresse(copy(Ligne,1,8));
                   delete(Ligne,1,8);
                   Nb_Ligne := compresse(copy(Ligne,1,3));
                   delete(Ligne,1,3);
                   Recherche := compresse(copy(Ligne,1,3));
                   delete(Ligne,1,3);
                   Affichage := compresse(copy(Ligne,1,3));
                   delete(Ligne,1,3);
              End;
              End;
           End;
     close(Fic_Config);
{$I+}
End;

{------------------------------------------------------------------------}

procedure Supprimer;

Begin
     Fond;
     Message(CTTitre,CFTitre,'  CONFIGURATION RS232  ',2,false);
     Message(CTTitre,CFTitre,' - Suppression - ',3,false);
{$I-}
     assign(Fic_Tmp,'RS232.TMP');
     rewrite(Fic_Tmp);

     assign(Fic_Config,'RS232.CFG');
     reset(Fic_Config);
     if ioresult <> 0 then Begin
        tempAlertes := 0;
        Alerte('Fichier des configurations introuvable !!');
        MontreCurseur;
        CoulFond(noir);
        CoulTexte(grisclair);
        clrscr;
        halt;
        End;

     for z := 1 to MaxProp do Proposition[z]^:= '';
     z := 1;
     while not eof(Fic_Config) do Begin
           readln(Fic_Config,Ligne);
           Proposition[z]^ := compresse(Ligne);
           readln(Fic_Config,Ligne);
           z := z + 1;
           End;
     Message(blanc,grisclair,'  Choix de la configuration  ',7,false);
     Resultat := 0;
     if not Choix(34,9,10,39,Resultat,Proposition) then exit
        else Nom_Config := majuscules(Proposition[Resultat]^);

     reset(Fic_Config);
     while not eof(Fic_Config) do Begin
           readln(Fic_Config,Ligne);
           if compresse(Ligne) = Nom_Config then
                   readln(Fic_Config,Ligne)
              else Begin
              writeln(Fic_Tmp,Ligne);
              readln(Fic_Config,Ligne);
              writeln(Fic_Tmp,Ligne);
              End;
           End;
     close (Fic_Tmp);
     close(Fic_Config);
     erase(Fic_Config);
     rename(Fic_Tmp,'RS232.CFG');
{$I+}
End;

{-----------------------------------------------------------------------}

procedure Menu_Config;

Begin
     Proposition[1]^ := 'Editer';
     Proposition[2]^ := 'Crer';
     Proposition[3]^ := 'Charger';
     Proposition[4]^ := 'Supprimer';
     Fond;
     Message(CTTitre,CFTitre,'  CONFIGURATION RS232  ',2,false);
     Message(CTMenu,CFMenu,'  Appuyez sur ESC pour sortir  ',21,false);
     CoulFond(CFMenu);
     CoulTexte(CTMenu);
     Resultat := 0;
     if not Choix(34,9,4,4,Resultat,Proposition) then exit
        else
            case Resultat of  1 : Editer;
                              2 : Creer;
                              3 : Lire;
                              4 : Supprimer;
            end;
     Param_Tmp := ParamRS[1];
     CalculReglage;
     ReglageRS[1] := Reglage_Tmp;
     Param_Tmp := ParamRS[2];
     CalculReglage;
     ReglageRS[2] := Reglage_Tmp;
End;

{--------------------------------------------------------------------------}

procedure Ferme_Config;

Begin
     for Z := 1 to 10 do dispose(Proposition[Z]);
End;

{--------------------------------------------------------------------------}

Begin
     Nom_Config := 'DEFAULT';
     for Z := 1 to MaxProp do new(Proposition[Z]);
     for Z := 1 to 10 do Proposition[Z]^ := '';
     with ParamRS[1] do
     Begin
          Port := Mess[1];
          BDonnees := Mess[2];
          BStop    := Mess[3];
          Parite   := Majuscules(Mess[4]);
          Vitesse  := Mess[5];
          Codage   := Majuscules(Mess[6]);
          if Codage = 'ISO' then Begin
                                      BDonnees := '7';
                                      Parite := 'PAIRE';
                                 End;
          if Codage = 'EIA' then Begin
                                      BDonnees := '7';
                                      Parite := 'IMPAIRE';
                                 End;
          Protocole := Majuscules(Mess[7]);
          Nb_Ligne := Mess[8];
          Recherche:= Majuscules(Mess[9]);
          Affichage:= Majuscules(Mess[10]);
     End;
     with ParamRS[2] do
     Begin
          Port := Mess[11];
          BDonnees := Mess[12];
          BStop    := Mess[13];
          Parite   := Majuscules(Mess[14]);
          Vitesse  := Mess[15];
          Codage   := Majuscules(Mess[16]);
          if Codage = 'ISO' then Begin
                                      BDonnees := '7';
                                      Parite := 'PAIRE';
                                 End;
          if Codage = 'EIA' then Begin
                                      BDonnees := '7';
                                      Parite := 'IMPAIRE';
                                 End;
          Protocole := Majuscules(Mess[17]);
          Nb_Ligne := Mess[18];
          Recherche:= Majuscules(Mess[19]);
          Affichage:= Majuscules(Mess[20]);
     End;
     Param_Tmp := ParamRS[1];
     CalculReglage;
     ReglageRS[1] := Reglage_Tmp;
     Param_Tmp := ParamRS[2];
     CalculReglage;
     ReglageRS[2] := Reglage_Tmp;
End.