unit RSEMSREC;

INTERFACE

uses crt,dos,rsglob,rsconfig,turbolib,turboftr;

const
    TpsAttente = 5;

var
    Reg : registers;
    EIA : boolean;
    ISO : boolean;

    CDebut : byte; {code caractre dbut}
    CFin   : byte; {code caractre fin}
    CFB1   : byte; {code fin de bloc numro 1}
    CFB2   : byte; {code fin de bloc numro 2}

    Chrono : longint;
    Compteur : integer;
    Reference : integer;
    Voir   : boolean;

Procedure RS232_Init;
Function Present : boolean;
Procedure Capture;
Procedure Restitution;
Procedure Code_EIA;
Procedure Emission;
Procedure Reception;
procedure Init_Activite(Num : integer);
Procedure Activite;

IMPLEMENTATION

{--------------------------------------------------------------------------}

Procedure RS232_Init; { Initialisation du Port srie }

Begin
     Reg.AH := 0;
     Reg.AL := Reglage;
     Reg.DX := Port;
     intr($14,Reg);
End;

{--------------------------------------------------------------------------}

Function Present : boolean;  { Present vaut true si un caractre }
                             { est disponible                    }
Begin
     Reg.AH := 3;
     Reg.DX := Port;
     intr($14,Reg);
     if Reg.AH and 1 = 1 then Present := true else Present := false;
End;

{--------------------------------------------------------------------------}

Procedure Capture;  { Capture et mmorisation des caractres }

Begin
     Reg.AH := 2;
     Reg.DX := Port;
     intr($14,Reg);
     Code := Reg.AL;
End;

{--------------------------------------------------------------------------}

Procedure Restitution;

Begin
     Reg.AH := 1;
     Reg.DX := Port;
     Reg.AL := Code;
     intr($14,Reg);
End;

{-------------------------------------------------------------------------}

Procedure Saute_Emission;

var
   Saute : integer;
   Err,N : integer;

Begin
     val(ParamRS[1].Nb_Ligne,Saute,Err);
     for N := 1 to Saute do
        repeat
             Caract := upcase(Recup_Car);
             Car_Suivant;
        until Caract = carRet;
End;

{-------------------------------------------------------------------------}

Procedure Saute_Reception;

var
   Saute : integer;
   Err,N : integer;

Begin
     val(ParamRS[2].Nb_Ligne,Saute,Err);
     for N := 1 to Saute do
         repeat
               if Present then Capture;
         until Code = CFB1 ;
End;

{-------------------------------------------------------------------------}

Procedure Recherche_Reception;

var
   Reference : string[1];
   Valeur    : char;

Begin
     if ParamRS[1].Recherche = 'NON' then exit;
     Reference := compresse(ParamRS[1].Recherche);
     repeat
           if Present then Capture;
           Valeur := chr(Code);
           if ParamRS[1].Codage = 'EIA' then begin
              Code_EIA;
              Valeur := Caract;
              end;
     until Valeur = Reference ;
End;

{-------------------------------------------------------------------------}

Procedure Recherche_Emission;

var
   Reference : string[1];

Begin
     if ParamRS[2].Recherche = 'NON' then exit;
     Reference := compresse(ParamRS[2].Recherche);
     repeat
          Caract := upcase(Recup_Car);
          Car_Suivant;
     until Caract = Reference;
End;

{------------------------------------------------------------------------}

Procedure Emission_ISO;

Begin
     Init_Activite(1);
     Val(ParamRS[1].Port,Port,Err);
     Port := Port - 1;
     Reglage := ReglageRS[1];
     RS232_Init;
     Fond;
     val(Mess[25],CDebut,Err);
     val(Mess[26],CFin,Err);
     val(Mess[29],CFB1,Err);
     val(Mess[30],CFB2,Err);
     Message(CTTitre,CFTitre,'  EMISSION RS232 ISO ',2,false);
     Message(CTMenu,CFMenu,'  Appuyez sur ESC pour sortir  ',24,false);
     if ParamRS[1].Affichage <> 'OUI' then Informe('Emission en cours ...');
     Code := 0;
     Restitution;
     Selection := ' ';
     Premier_Car;
     window(3,4,77,23);
     gotoxy(2,14);
     delay(Pause);
     Recherche_Emission;
     if ParamRS[1].Nb_Ligne <> '0' then Saute_Emission;
     if ParamRS[1].Affichage = 'OUI' then
       repeat
           Caract := upcase(Recup_Car);
           write(Caract);
           if (Caract='O') and (Liste^.Data[Num_Actuel-1]=#10) then Caract := ':';
           if Caract = carRet then
              Begin
                   Code := CFB1;
                   Restitution;
                   if CFB2 > 0 then Begin
                                         Code := CFB2;
                                         Restitution;
                                    End;
                   Car_Suivant;
                   Caract := upcase(Recup_Car);
                   gotoxy(2,14);
                   clreol;
                   Car_Suivant;
              End
              else Begin
                        Code := ord(Caract);
                        if Code <> CFB2 then Restitution;
                        Car_Suivant;
                   End;
         if keypressed then Begin
                            Selection := readkey;
                            if Selection = ' ' then Begin
                                                repeat
                                                    Selection := readkey;
                                                until Selection=' ';
                                                End;
                            End;
       until Tout_Fait or (Selection = #27)

       else
       repeat
           Caract := upcase(Recup_Car);
           Activite;
           if (Caract='O') and (Liste^.Data[Num_Actuel-1]=#10) then Caract := ':';
           if Caract = carRet then
              Begin
                   Code := CFB1;
                   Restitution;
                   if CFB2 > 0 then Begin
                                         Code := CFB2;
                                         Restitution;
                                    End;
                   Car_Suivant;
                   Caract := upcase(Recup_Car);
                   Car_Suivant;
              End
              else Begin
                        Code := ord(Caract);
                        if Code <> CFB2 then Restitution;
                        Car_Suivant;
                   End;
         if keypressed then Begin
                            Selection := readkey;
                            if Selection = ' ' then Begin
                                                repeat
                                                    Selection := readkey;
                                                until Selection=' ';
                                                End;
                            End;
       until Tout_Fait or (Selection = #27);
     window(1,1,80,25);
     beep;
End;

{------------------------------------------------------------------------}

Procedure Reception_ISO;

Begin
     Init_Activite(2);
     Val(ParamRS[2].Port,Port,Err);
     Port := Port - 1;
     Reglage := ReglageRS[2];
     RS232_Init;
     Fond;
     val(Mess[25],CDebut,Err);
     val(Mess[26],CFin,Err);
     val(Mess[29],CFB1,Err);
     val(Mess[30],CFB2,Err);
     Message(CTTitre,CFTitre,'  RECEPTION RS232 ISO ',2,false);
     Message(CTMenu,CFMenu,'  Appuyez sur ESC pour sortir  ',24,false);
     if ParamRS[2].Affichage <> 'OUI' then Informe('Reception en cours ...');
     Code := 0;
     Restitution;
     Selection := ' ';
     RAZ_Liste;
     Timer_Init(Chrono);
     window(3,4,77,23);
     gotoxy(2,14);
     delay(Pause);
     Recherche_Reception;
     if ParamRS[2].Nb_Ligne <> '0' then Saute_Reception;

     if ParamRS[2].Affichage = 'OUI' then
       repeat
          if Present then
          Begin
             Timer_Init(Chrono);
             Capture;
             if Code <> 0 then Begin
                  if Code = CFB1 then
                  Begin
                    Caract := #13;
                    Stock_Car(Caract);
                    gotoxy(2,14);
                    Caract := #10;
                    Stock_Car(Caract);
                    clreol;
                  End
                  else if Code = CFB2 then Begin
                                            End
                        else Begin
                                  Caract := chr(Code);
         if (Caract=':') and (Liste^.Data[Num_Actuel]=#10) then Caract := 'O';
                             Stock_Car(Caract);
                             write(Caract);
                             End;
             End;
          End;
       if (Timer_Lect(Chrono) > TpsAttente) and (Nombre_Car > 1)
                                    then Selection := #27;
       if keypressed then Selection := readkey;
       until Selection = #27

       else
       repeat
          if Present then
          Begin
             Timer_Init(Chrono);
             Capture;
             Activite;
             if Code <> 0 then
             Begin
               if Code = CFB1 then
               Begin
                 Caract := #13;
                 Stock_Car(Caract);
                 Caract := #10;
                 Stock_Car(Caract);
               End
               else if Code = CFB2 then
                    Begin
                    End
                    else
                    Begin
                      Caract := chr(Code);
                      if (Caract=':') and (Liste^.Data[Num_Actuel]=#10) then
                          Caract := 'O';
                      Stock_Car(Caract);
                    End;
             End;
          End;
       if (Timer_Lect(Chrono) > TpsAttente) and (Nombre_Car > 1)
                                    then Selection := #27;
       if keypressed then Selection := readkey;
       until Selection = #27;
     window(1,1,80,25);
     beep;
End;

{--------------------------------------------------------------------------}

Procedure Code_EIA;

Begin
     case Caract of
                   '0' : Code := 32 ;
                   '1' : Code := 1;
                   '2' : Code := 2;
                   '3' : Code := 19;
                   '4' : Code := 4;
                   '5' : Code := 21;
                   '6' : Code := 22;
                   '7' : Code := 7;
                   '8' : Code := 8;
                   '9' : Code := 25;
                   'A' : Code := 97;
                   'B' : Code := 98;
                   'C' : Code := 115;
                   'D' : Code := 100;
                   'E' : Code := 117;
                   'F' : Code := 118;
                   'G' : Code := 103;
                   'H' : Code := 104;
                   'I' : Code := 121;
                   'J' : Code := 81;
                   'K' : Code := 82;
                   'L' : Code := 67;
                   'M' : Code := 84;
                   'N' : Code := 69;
                   'O' : Code := 70;
                   'P' : Code := 87;
                   'Q' : Code := 88;
                   'R' : Code := 73;
                   'S' : Code := 50;
                   'T' : Code := 35;
                   'U' : Code := 52;
                   'V' : Code := 37;
                   'W' : Code := 38;
                   'X' : Code := 55;
                   'Y' : Code := 56;
                   'Z' : Code := 41;
                   '' : Code := 127;
                   #0  : Code := 0;
                   #8  : Code := 42;
                   #9  : Code := 62;
                   #13 : Code := 128;
                   ' ' : Code := 16;
                   '%' : Code := 11;
                   '(' : Code := 26;
                   ')' : Code := 74;
                   '+' : Code := 112;
                   '-' : Code := 64;
                   '/' : Code := 49;
                   '.' : Code := 107;
                   '&' : Code := 14;
                   ',' : Code := 59;
                   else Code := ord(Caract);
    End;
End;

{-----------------------------------------------------------------------}

Procedure Emission_EIA;

Begin
     Init_Activite(1);
     Val(ParamRS[1].Port,Port,Err);
     Port := Port - 1;
     Reglage := ReglageRS[1];
     RS232_Init;
     Fond;
     val(Mess[23],CDebut,Err);
     val(Mess[24],CFin,Err);
     val(Mess[27],CFB1,Err);
     val(Mess[28],CFB2,Err);
     Message(CTTitre,CFTitre,'  EMISSION RS232 EIA ',2,false);
     Message(CTMenu,CFMenu,'  Appuyez sur ESC pour sortir  ',24,false);
     if ParamRS[1].Affichage <> 'OUI' then Informe('Emission en cours ...');
     Code := 0;
     Restitution;
     Selection := ' ';
     Premier_Car;
     window(3,4,77,23);
     gotoxy(2,14);
     delay(Pause);
     Recherche_Emission;
     if ParamRS[1].Nb_Ligne <> '0' then Saute_Emission;
     if ParamRS[1].Affichage = 'OUI' then
       repeat
           Caract := upcase(Recup_Car);
           write(Caract);
           if Caract = carRet then
              Begin
                   Code := CFB1;
                   Restitution;
                   if CFB2 > 0 then Begin
                                         Code := CFB2;
                                         Restitution;
                                    End;
                   Car_Suivant;
                   Caract := upcase(Recup_Car);
                   gotoxy(2,14);
                   clreol;
                   Car_Suivant;
              End
              else Begin
                        Code_EIA;
                        Restitution;
                        Car_Suivant;
                   End;
         if keypressed then Begin
                            Selection := readkey;
                            if Selection = ' ' then Begin
                                                repeat
                                                    Selection := readkey;
                                                until Selection=' ';
                                                End;
                            End;
       until Tout_Fait or (Selection = #27)

       else
       repeat
           Caract := upcase(Recup_Car);
           Activite;
           if Caract = carRet then
              Begin
                   Code := CFB1;
                   Restitution;
                   if CFB2 > 0 then Begin
                                         Code := CFB2;
                                         Restitution;
                                    End;
                   Car_Suivant;
                   Caract := upcase(Recup_Car);
                   Car_Suivant;
              End
              else Begin
                        Code_EIA;
                        Restitution;
                        Car_Suivant;
                   End;
         if keypressed then Begin
                            Selection := readkey;
                            if Selection = ' ' then Begin
                                                repeat
                                                    Selection := readkey;
                                                until Selection=' ';
                                                End;
                            End;
       until Tout_Fait or (Selection = #27);

     window(1,1,80,25);
     beep;
End;

{-----------------------------------------------------------------------}

Procedure Decode_EIA;

Begin
     Caract := ' ';
     case Code of
                 32 : Caract := '0';
                 1  : Caract := '1';
                 2  : Caract := '2';
                 19 : Caract := '3';
                 4  : Caract := '4';
                 21 : Caract := '5';
                 22 : Caract := '6';
                 7  : Caract := '7';
                 8  : Caract := '8';
                 25 : Caract := '9';
                 97 : Caract := 'A';
                 98 : Caract := 'B';
                 115: Caract := 'C';
                 100: Caract := 'D';
                 117: Caract := 'E';
                 118: Caract := 'F';
                 103: Caract := 'G';
                 104: Caract := 'H';
                 121: Caract := 'I';
                 81 : Caract := 'J';
                 82 : Caract := 'K';
                 67 : Caract := 'L';
                 84 : Caract := 'M';
                 69 : Caract := 'N';
                 70 : Caract := 'O';
                 87 : Caract := 'P';
                 88 : Caract := 'Q';
                 73 : Caract := 'R';
                 50 : Caract := 'S';
                 35 : Caract := 'T';
                 52 : Caract := 'U';
                 37 : Caract := 'V';
                 38 : Caract := 'W';
                 55 : Caract := 'X';
                 56 : Caract := 'Y';
                 41 : Caract := 'Z';
                 127: Caract := '';
                 0  : Caract := #0;
                 42 : Caract := #8;
                 62 : Caract := #9;
                 128: Caract := #13;
                 16 : Caract := ' ';
                 11 : Caract := '%';
                 26 : Caract := '(';
                 74 : Caract := ')';
                 112: Caract := '+';
                 64 : Caract := '-';
                 49 : Caract := '/';
                 107: Caract := '.';
                 14 : Caract := '&';
                 59 : Caract := ',';
                 else Caract := chr(Code);
     End;
End;

{------------------------------------------------------------------------}

Procedure Reception_EIA;

Begin
     Init_Activite(2);
     Val(ParamRS[2].Port,Port,Err);
     Port := Port - 1;
     Reglage := ReglageRS[2];
     RS232_Init;
     Fond;
     val(Mess[23],CDebut,Err);
     val(Mess[24],CFin,Err);
     val(Mess[27],CFB1,Err);
     val(Mess[28],CFB2,Err);
     Message(CTTitre,CFTitre,'  RECEPTION RS232 EIA ',2,false);
     Message(CTMenu,CFMenu,'  Appuyez sur ESC pour sortir  ',24,false);
     if ParamRS[2].Affichage <> 'OUI' then Informe('Reception en cours ...');
     Code := 0;
     Restitution;
     RAZ_Liste;
     Timer_Init(Chrono);
     Selection := ' ';
     window(3,4,77,23);
     gotoxy(2,14);
     delay(Pause);
     Recherche_Reception;
     if ParamRS[2].Nb_Ligne <> '0' then Saute_Reception;
     if ParamRS[2].Affichage = 'OUI' then
       repeat
        if Present then Begin
           Timer_Init(Chrono);
           Capture;
           if Code <> 0 then Begin
                if Code = CFB1 then
                   Begin
                     Caract := #13;
                     Stock_Car(Caract);
                      gotoxy(2,14);
                      Caract := #10;
                      Stock_Car(Caract);
                      clreol;
                   End
                 else if Code = CFB2 then Begin
                                          End
                      else Begin
                                Decode_EIA;
                                Stock_Car(Caract);
                                write(Caract);
                           End;
           End;
        End;
        if (Timer_Lect(Chrono) > TpsAttente) and (Nombre_Car > 1)
                                    then Selection := #27;
        if keypressed then Selection := readkey;
       until Selection = #27

       else
       repeat
        if Present then Begin
           Timer_Init(Chrono);
           Capture;
           Activite;
           if Code <> 0 then Begin
                if Code = CFB1 then
                   Begin
                     Caract := #13;
                     Stock_Car(Caract);
                      Caract := #10;
                      Stock_Car(Caract);
                   End
                 else if Code = CFB2 then Begin
                                          End
                      else Begin
                                Decode_EIA;
                                Stock_Car(Caract);
                           End;
           End;
        End;
        if (Timer_Lect(Chrono) > TpsAttente) and (Nombre_Car > 1)
                                    then Selection := #27;
        if keypressed then Selection := readkey;
       until Selection = #27;
       window(1,1,80,25);
       beep;
End;

{-----------------------------------------------------------------------}

Procedure Emission_ASCII;

Begin
     Init_Activite(1);
     Val(ParamRS[1].Port,Port,Err);
     Port := Port - 1;
     Reglage := ReglageRS[1];
     RS232_Init;
     Fond;
     Message(CTTitre,CFTitre,' EMISSION RS232 ASCII ',2,false);
     Message(CTMenu,CFMenu,'  Appuyez sur ESC pour sortir  ',24,false);
     if ParamRS[1].Affichage <> 'OUI' then Informe('Emission en cours ...');
     Code := 0;
     Restitution;
     Selection := ' ';
     Premier_Car;
     window(3,4,77,23);
     delay(Pause);
     Recherche_Emission;
     if ParamRS[1].Nb_Ligne <> '0' then Saute_Emission;
     if ParamRS[1].Affichage = 'OUI' then
       repeat
           Caract := Recup_Car;
           Code := ord(Caract);
           Restitution;
           if Code in [7,8] then beep
                            else write(Caract);
           Car_Suivant;
           if keypressed then Begin
                                   Selection := readkey;
                                 if Selection = ' ' then Begin
                                                  repeat
                                                        Selection := readkey;
                                                  until Selection=' ';
                                                  End;
                                 End;
       until Tout_Fait or (Selection = #27)

       else
       repeat
           Caract := Recup_Car;
           Activite;
           Code := ord(Caract);
           Restitution;
           Car_Suivant;
           if keypressed then Begin
                                   Selection := readkey;
                                 if Selection = ' ' then Begin
                                                  repeat
                                                        Selection := readkey;
                                                  until Selection=' ';
                                                  End;
                                 End;
       until Tout_Fait or (Selection = #27);

     window(1,1,80,25);
     beep;
End;

{------------------------------------------------------------------------}

Procedure Reception_ASCII;

Begin
     Init_Activite(2);
     Val(ParamRS[2].Port,Port,Err);
     Port := Port - 1;
     Reglage := ReglageRS[2];
     RS232_Init;
     Fond;
     Message(CTTitre,CFTitre,' RECEPTION RS232 ASCII ',2,false);
     Message(CTMenu,CFMenu,'  Appuyez sur ESC pour sortir  ',24,false);
     if ParamRS[2].Affichage <> 'OUI' then Informe('Reception en cours ...');
     Code := 0;
     Restitution;
     Raz_Liste;
     Timer_Init(Chrono);
     Selection := ' ';
     window(3,4,77,23);
     delay(Pause);
     Recherche_Reception;
     if ParamRS[2].Nb_Ligne <> '0' then Saute_Reception;
     if ParamRS[2].Affichage = 'OUI' then
       repeat
       if Present then Begin
                          Timer_Init(Chrono);
                          Capture;
                          Caract := chr(Code);
                          Stock_Car(Caract);
                          if Code in [7,8] then beep
                                           else write(Caract);
                     End;
       if (Timer_Lect(Chrono) > TpsAttente) and (Nombre_Car > 1)
                                    then Selection := #27;
       if keypressed then Selection := readkey;
       until Selection = #27

       else
       repeat
       if Present then Begin
                          Timer_Init(Chrono);
                          Capture;
                          Activite;
                          Caract := chr(Code);
                          Stock_Car(Caract);
                     End;
       if (Timer_Lect(Chrono) > TpsAttente) and (Nombre_Car > 1)
                                    then Selection := #27;
       if keypressed then Selection := readkey;
       until Selection = #27;

     window(1,1,80,25);
     beep;
End;

{------------------------------------------------------------------------}

procedure Emission;

Begin
     with ParamRS[1] do Begin
          if Codage = 'ISO' then Emission_ISO;
          if Codage = 'EIA' then Emission_EIA;
          if Codage = 'ASCII' then Emission_ASCII;
     End;
End;

{------------------------------------------------------------------------}

procedure Reception;

Begin
     with ParamRS[2] do Begin
          if Codage = 'ISO' then Reception_ISO;
          if Codage = 'EIA' then Reception_EIA;
          if Codage = 'ASCII' then Reception_ASCII;
     End;
End;

{------------------------------------------------------------------------}

procedure Init_Activite(Num : integer);

Begin
     Compteur := 0;
     Voir := false;
     Val(ParamRS[Num].Vitesse,Reference,Err);
     Reference := Reference div 10;
End;

{------------------------------------------------------------------------}

procedure Activite;

Begin
  inc(Compteur);
  if (Compteur = Reference) then
  Begin
       Voir := not Voir;
       gotoXY(38,11);
       if Voir then write('')
               else write('');
       Compteur := 0;
  End;
End;

{------------------------------------------------------------------------}

Begin
     ISO := false;
     EIA := false;
End.