unit RSGLOB;

INTERFACE

uses crt,printer,turbolib,turbotxt,turboftr;

const
     Pause  = 1000;  {tempo en millisecondes}
     Nb_Messages = 50 ; {nombre de  message dans rs232.dat}
     CFond = bleu; {couleur fond}
     CTexte = blanc; {couleur texte}
     CFTitre = rouge; {couleur fond titres}
     CTTitre = jaune; {couleur texte titres}
     CFMenu = bleuciel; {couleur fond menus}
     CTMenu = noir; {couleur texte menus}
     Reste = 1024; {seuil mmoire pleine}

type
    listeptr = ^noeud;
    noeud = record
                  data      : array [1..65535] of char;
            end;
var
     Mess         : array [1..Nb_Messages] of string[80];
     Fichier_Mess : text;
     Mess_Tempo   : string[80];
     Num_Mess     : 1..Nb_Messages;

     Code       : byte; {code mis ou reu}
     Caract     : char; {caractre lu ou  stocker}
     Liste      : listeptr; {Premier pointeur de la liste}
     Car_Actuel : char;
     Num_Actuel : word;
     Nombre_Car : word;

     Repertoire : NomRep; {repertoire de stockage/lecture}
     Rep_Tempo  : NomRep;
     Nom        : NomFichier; {nom du fichier de stockage/lecture}
     Nom_Tempo  : NomFichier;
     Masque     : NomFichier; {masque de choix fichier}
     Fichier    : text;{file of char; {fichier  crire ou lire}
     Buf        : array [1..5119] of char; {buffer tampon de 5 Ko}

     Selection : char;
     Err       : integer;
     Resultat  : byte; {numero du rsultat d'un choix}

     Nom_Config: string[30];
     Reglage : byte; {rglage RS actif}
     Port    : byte; {port actif}

procedure Fond;
procedure Informe(Texte : str80);
procedure Lit_Messages;
procedure Trop_de_Car;
procedure Pas_assez_de_Mem;
procedure Init_Liste;
procedure RAZ_Liste;
procedure Vide_Liste;
function Rien_En_Mem : boolean;
function Tout_Fait : boolean;
procedure Stock_Car(LeCar : char);
function Recup_Car : char;
procedure Car_Precedent;
procedure Car_Suivant;
function Pas_De_Precedent : boolean;
function Pas_De_Suivant : boolean;
procedure Premier_Car;
procedure Sauvegarder; { Sauvegarde des caractres capturs }
procedure Charger; { Chargement d'un fichier contenant des caractres }
procedure Visualiser;
procedure Imprimer;

IMPLEMENTATION

{-------------------------------------------------------------------------}

procedure Fond;

Begin
     CoulTexte(CTexte);
     CoulFond(CFond);
     RectTexte(2,1,79,25,2,true);
End;

{-------------------------------------------------------------------------}

procedure Informe(Texte : str80);

var
    Boite : RectTxt;

Begin
     CoulTexte(CTMenu);
     CoulFond(CFMenu);
     CentreRect(Boite,length(Texte) + 2,3);
     with Boite do
          RectTexte(x1,y1,x2,y2,2,true);
     CentreTexte(13,Texte);
End;

{-------------------------------------------------------------------------}

procedure Lit_Messages;

Begin
     assign (Fichier_Mess,'RS232.DAT');
{$I-}
     reset (Fichier_Mess);
{$I+}
     if ioresult <> 0 then Begin
        tempAlertes := 0;
        Alerte('Fichier message introuvable !!');
        MontreCurseur;
        CoulFond(noir);
        CoulTexte(grisclair);
        clrscr;
        halt;
        End;
     for Num_Mess := 1 to Nb_Messages do Begin
         repeat
               readln (Fichier_Mess,Mess_Tempo);
         until pos('#',Mess_Tempo) <> 0 ;
         delete (Mess_Tempo,1,pos('#',Mess_Tempo));
         Mess[Num_Mess] := Mess_Tempo;
         End;
     close (Fichier_Mess);
End;

{---------------------------------------------------------------------------}

procedure Trop_De_Car;

Begin
     tempAlertes :=0;
     CoulTextes := blanc;
     Alerte('Trop grand nombre de caractres !!');
     if keypressed then Selection := readkey;
End;

{---------------------------------------------------------------------------}

procedure Pas_assez_de_Mem;

Begin
     tempAlertes :=0;
     CoulTextes := blanc;
     Alerte('Pas assez de mmoire !!');
     if keypressed then Selection := readkey;
End;

{---------------------------------------------------------------------------}

procedure Init_Liste;

Begin
  New(Liste);
  RAZ_Liste;
End;

{---------------------------------------------------------------------------}

procedure RAZ_Liste;

Begin
  Num_Actuel := 1;
  while (Liste^.Data[Num_Actuel] <> #255) and (Num_Actuel <= 65635) do
  Begin
    Liste^.Data[Num_Actuel] := #255;
    inc(Num_Actuel);
  End;
  Num_Actuel := 0;
  Nombre_Car := 0;
End;

{---------------------------------------------------------------------------}

procedure Vide_Liste;

Begin
  Dispose(Liste);
End;

{---------------------------------------------------------------------------}

function Rien_En_Mem : boolean;

Begin
  Rien_En_Mem := Liste^.Data[1] = #255;
End;

{---------------------------------------------------------------------------}

function Tout_Fait : boolean;

Begin
  Tout_Fait := (Liste^.Data[Num_Actuel] = #255) or (Num_Actuel > 65535);
End;

{---------------------------------------------------------------------------}

procedure Stock_Car(LeCar : char);

Begin
  inc(Nombre_Car);
  inc(Num_Actuel);
  Liste^.Data[Nombre_Car] := LeCar;
End;

{---------------------------------------------------------------------------}

function Recup_Car : char;

Begin
  Recup_Car := Liste^.Data[Num_Actuel];
End;

{---------------------------------------------------------------------------}

procedure Car_Precedent;

Begin
  dec(Num_Actuel);
End;

{---------------------------------------------------------------------------}

procedure Car_Suivant;

Begin
  inc(Num_Actuel);
End;

{---------------------------------------------------------------------------}

function Pas_De_Precedent : boolean;

Begin
  Pas_De_Precedent := Num_Actuel = 1;
End;

{---------------------------------------------------------------------------}

function Pas_De_Suivant : boolean;

Begin
  Pas_De_suivant := Liste^.Data[Num_Actuel + 1] = #255;
End;

{---------------------------------------------------------------------------}

procedure Premier_Car;

Begin
  Num_Actuel := 1;
End;

{---------------------------------------------------------------------------}

procedure Sauvegarder; { Sauvegarde des caractres capturs }

var
   Reponse : boolean;
   Nom_Fic : str80;

Begin
     Reponse := true;
     Fond;
     Message(CTTitre,CFTitre,'  Sauvegarde programme  ',2,false);
     CoulDialogues := grisclair;
     CoulTextes := blanc;
     repeat
           Rep_Tempo :=
                  DialogueTexte('Rpertoire de stockage :',Repertoire,40);
     until RepExiste(Rep_Tempo);
     if Rep_Tempo = CarNul then exit;
     Repertoire := Rep_Tempo;
     if (length(Repertoire) > 3) and (Repertoire[length(Repertoire)] <> '\')
        then Repertoire := Repertoire + '\';
     repeat
       Nom_Tempo := DialogueTexte('Nom du fichier de stockage :',Nom,12);
       if Nom_Tempo = CarNul then exit;
       Nom := Nom_Tempo;
       Nom_Fic := Repertoire + Nom;
       if FicExiste(Nom_Fic) then
          Reponse := DialogueBout(' Fichier existant.Ecraser ','NON','OUI')
          else Reponse := false;
     until Reponse = false;
     Informe(' Sauvegarde en cours ... ');
     assign(Fichier,Nom_Fic);
     settextbuf(Fichier,Buf);
     rewrite(Fichier);
     Premier_Car;
     repeat
       write(Fichier,Recup_Car);
       Car_Suivant;
     until Tout_fait;
     close(Fichier);
     Beep;
End;

{---------------------------------------------------------------------------}

procedure Charger; { Chargement d'un fichier contenant des caractres }
                   { prcdement capturs (compatible format RS 232)  }
var
    Nom_Fic   : str80;

Begin
     Fond;
     Message(CTTitre,CFTitre,'  Chargement programme  ',2,false);
     CoulDialogues := grisclair;
     CoulTextes := blanc;
     repeat
           Rep_Tempo :=
                  DialogueTexte('Rpertoire de lecture :',Repertoire,40);
     until RepExiste(Rep_Tempo);
     if Rep_Tempo = CarNul then exit;
     Repertoire := Rep_Tempo;
     if (length(Repertoire) > 3) and (Repertoire[length(Repertoire)] <> '\')
        then Repertoire := Repertoire + '\';
     Masque := DialogueTexte('Masque de choix :',Masque,12);
     if Masque = CarNul then exit;
     CoulDialogues := CFMenu;
     CoulTextes := CTMenu;
     if ChoixFichier(27,6,Repertoire,Masque,'Choix du fichier') then
     Begin
       Nom_Fic := Repertoire + Masque;
       Informe(' Chargement en cours ... ');
       if Masque = #255 then exit;
       assign(Fichier,Nom_Fic);
       settextbuf(Fichier,Buf);
       reset(Fichier);
       RAZ_Liste;
       while not eof(Fichier) do
             Begin
                  read(Fichier,Caract);
                  Stock_Car(caract);
             End;
       Close(Fichier);
       Beep;
     End;
End;

{---------------------------------------------------------------------------}

procedure Affiche_Page;

var N : byte;

Begin
     clrscr;
     N := 1;
     repeat
         repeat
               Code := ord(Recup_Car);
               if Code <> 0 then Begin
                                      write(chr(Code));
                                 End;
               Car_Suivant;
         until (chr(Code) = carRet) or Tout_Fait;
         inc(N);
     until (N = 19) or Tout_Fait;
     if Recup_Car = #10 then
     Begin
       write(#10);
       Car_Suivant;
     End;
End;

{---------------------------------------------------------------------------}

procedure Visualiser;

   {****************************************}

   procedure Descend;

   var
      Ligne : byte;

   Begin
        Ligne := 0;
        repeat
              repeat
                    Car_Suivant;
              until (Recup_Car = carRet) or Pas_De_Suivant;
              inc(Ligne);
        until (Ligne = 19) or Pas_De_Suivant;
        for Ligne := 1 to 19 do
              repeat
                    Car_Precedent;
              until (Recup_Car = carRet) or Pas_De_Precedent;
        Car_Suivant;
   End;

   {****************************************}

   procedure Monte;

   var
      Ligne : byte;

   Begin
        Ligne := 0;
        repeat
              repeat
                    Car_Precedent;
              until (Recup_Car = carRet) or Pas_De_Precedent;
              inc(Ligne);
        until (Ligne = (18 + 19)) or Pas_De_Precedent;
        if not Pas_De_Precedent then Car_suivant;
   End;

   {****************************************}

Begin
     Selection := ' ';
     Premier_Car;
     if Rien_En_Mem then Begin
                               Beep;
                               exit;{S'il n'y a pas eu de capture alors on sort}
                          End;
     Fond;
     Message(CTTitre,CFTitre,'  Visualisation programme  ',2,false);
     Message(CTMenu,CFMenu,
             ' Appuyez sur ESC pour sortir ',24,false);
     window(3,4,78,22);
     repeat
           Affiche_Page;
           repeat
           Selection := readkey;
           until Selection in [flchPgBas,flchPgHaut,carEsc];
           case Selection of
                flchPgBas  : if not Pas_De_Suivant then Descend;
                flchPgHaut : if not Pas_De_Precedent then Monte;
           end;
     until Selection=#27;

     window(1,1,80,25);
End;

{---------------------------------------------------------------------------}

procedure Imprimer;

var
   Temporaire : longint;

Begin
     Selection := ' ';
     Premier_Car;
     if Rien_En_Mem then exit;{S'il n'y a pas eu de capture alors on sort}
     Fond;
     Message(CTTitre,CFTitre,'  Impression programme  ',2,false);
     Message(CTMenu,CFMenu,
                       ' Espace : Arrt de l''impression   ',23,false);
     Message(CTMenu,CFMenu,
        ' Appuyez sur ESC pour sortir ',24,false);
     Informe(' Impression en cours ... ');
     repeat
           Code := ord(Recup_Car);
           if Code <> 0 then Begin
                                  write(lst,chr(Code));
                             End;
           Car_Suivant;
           if keypressed then
           Begin
             Selection := readkey;
             if Selection = ' ' then
             Begin
               Message(CFMenu,CTMenu,
                       ' Espace : Reprise de l''impression ',23,false);
               repeat
                 Selection := readkey;
               until Selection=' ';
               Message(CTMenu,CFMenu,
                       ' Espace : Arrt de l''impression   ',23,false);
             End;
           End;
     until Tout_Fait or (Selection = #27);
End;

{---------------------------------------------------------------------------}

Begin
     Lit_Messages;
     Repertoire := Mess[31];
     Nom := Mess[32];
     Masque := Mess[33];
END.